function documentCoordinateToViewportCoordinate(x,y) {
    var coord = new Object();
    coord.x = x - window.pageXOffset;
    coord.y = y - window.pageYOffset;
    return coord;
}

function viewportCoordinateToDocumentCoordinate(x,y) {
    var coord = new Object();
    coord.x = x + window.pageXOffset;
    coord.y = y + window.pageYOffset;
    return coord;
}

function elementFromPointIsUsingViewPortCoordinates() {
    if (window.pageYOffset > 0) {     // page scrolled down
        return (window.document.elementFromPoint(0, window.pageYOffset + window.innerHeight -1) == null);
    } else if (window.pageXOffset > 0) {   // page scrolled to the right
        return (window.document.elementFromPoint(window.pageXOffset + window.innerWidth -1, 0) == null);
    }
    return false; // no scrolling, don't care
}

function elementFromDocumentPoint(x,y) {
    if (elementFromPointIsUsingViewPortCoordinates()) {
        var coord = documentCoordinateToViewportCoordinate(x,y);
        return window.document.elementFromPoint(coord.x,coord.y);
    } else {
        return window.document.elementFromPoint(x,y);
    }
}

function elementFromViewportPoint(x,y) {
    if (elementFromPointIsUsingViewPortCoordinates()) {
        return window.document.elementFromPoint(x,y);
    } else {
        var coord = viewportCoordinateToDocumentCoordinate(x,y);
        return window.document.elementFromPoint(coord.x,coord.y);
    }
}



function MyAppGetHTMLElementsAtPoint(x,y) {
    var tags = ",";
    var e = elementFromViewportPoint(x,y);
    while (e) {
        if (e.tagName) {
            tags += e.tagName + ',';
        }
        e = e.parentNode;
    }
    return tags;
}

function MyAppGetLinkSRCAtPoint(x,y) {
    var tags = "";
    var coord = viewportCoordinateToDocumentCoordinate(x,y);
    var e = elementFromViewportPoint(x,y);
    while (e) {
        if (e.src) {
            tags += e.src;
            break;
        }
        e = e.parentNode;
    }
    return tags;
}

function MyAppGetHTMLElementsTextAtPoint(x,y){
    var tags = "";
    var coord = viewportCoordinateToDocumentCoordinate(x,y);
    var e = elementFromViewportPoint(x,y);
    while (e) {
        if (e.text) {
            tags += e.text;
            break;
        }
        e = e.parentNode;
    }
    return tags;
}

function MyAppGetLinkHREFAtPoint(x,y) {
    var tags = "";
    var coord = viewportCoordinateToDocumentCoordinate(x,y);
    var e = elementFromViewportPoint(x,y);
    while (e) {
        if (e.href) {
            tags += e.href;
            break;
        }
        e = e.parentNode;
    }
    return tags;
}

function SelectImage() {
    var a = document.images;
    for (var i = 0; i < a.length; i++) {
        e = a[i];
        if (e.clientWidth > window.innerWidth / 2) {
            tags = e.src;
            return tags;
        }
    }
    return null;
}

function getHighlightedString() {
    var text        = window.getSelection();
    if (text.anchorOffset < text.focusOffset) {
        return text.anchorNode.textContent.substr(text.anchorOffset, text.focusOffset - text.anchorOffset);
    } else {
        return text.anchorNode.textContent.substr(text.focusOffset, text.anchorOffset - text.focusOffset);
    }
}