;(function() {

// @NOTE:
// 需要浏览器把 placeholder 替换掉.
var currentColorMode = '__placeholder--mode__';
var __defined__ = 'sogou-color-mode';
var __defined_reset__ = 'sogou-color-mode--reset';
var __defined_ignore__ = 'sogou-color-mode--ignore';
var __defined_ignore_fullpage__ = 'sogou-color-mode--ignore-fullpage';
var __debug__ = false;

window.requestAnimationFrame = requestAnimationFrame || webkitRequestAnimationFrame || function(f) {
  return setTimeout(f, 0)
}

var html = document.querySelector('html');

// @NOTE:
// 样式只会注入一次.
;(function() {
  var styleNode = document.createElement('style');
  styleNode.type = "text/css";
  var styleTextPlaceholder = '__placeholder--style__';
  var styleText = document.createTextNode(styleTextPlaceholder);
  styleNode.appendChild(styleText);
  var heads = document.getElementsByTagName('head');
  if (heads && heads.length > 0) {
    heads[0].appendChild(styleNode);
  } else if(html) {
    html.appendChild(styleNode);
  } else {
    setTimeout(arguments.callee, 10);
  }
}());

if (typeof window.SogouUtilsEX != 'object') {
  window.SogouUtilsEX = {};
}

if (window.SogouUtilsEX.toggleColorMode) {
  window.SogouUtilsEX.toggleColorMode.html = html;
  window.SogouUtilsEX.toggleColorMode(currentColorMode, 'init');
  return;
}

function type(s) {
  return Object.prototype.toString.call(s).slice(8, -1).toLowerCase();
}

function inarray(item, array) {
  var ret = false;
  for (var i = 0, l = array.length; i < l; ++i) {
    if (item.toLowerCase() === array[i].toLowerCase()) {
      ret = true;
      break;
    }
  }
  return ret;
}

function matches(condition) {
  var _type = type(condition);
  var ret = false;
  if (_type === 'function') {
    ret = condition(location.href);
  } else if (_type === 'string') {
    ret = location.href.indexOf(condition) === 0;
  } else if (_type === 'regexp') {
    ret = condition.test(location.href);
  } else if (_type === 'array') {
    for (var i = 0; i < condition.length; ++i) {
      var f = condition[i];
      ret = matches(f);
      if (ret) {
        break;
      }
    }
  }
  return ret;
}

function walk(root, conf) {
  conf = type(conf) == 'object' ? conf : {
    handle: function() {},
    layer: 0
  };
  if (type(root) !== 'array') root = [root];
  var i = 0, l = root.length;
  while (i < l) {
    var element = root[i];
    var deep = true;
    if (type(conf.handle) == 'function') {
      if (conf.handle(element) === false) {
        deep = false;
      }
    }
    if (deep && element) {
      var children = element.childNodes;
      if (children && children.length) {
        ++conf.layer;
        var _children = Array.prototype.slice.call(children);
        walk(_children, conf);
        --conf.layer;
      }
    }
    ++i;
  }
  if (conf.layer === 0) {
    if (type(conf.complete) == 'function') {
      conf.complete();
    }
  }
}

function walkToRoot(node, handle, context) {
  while (node) {
    if (handle(node) === true) {
      return node;
    }
    if (node === context) {
      break;
    } else {
      node = node.parentNode;
    }
  }
  return null;
}

var hacks = {
  // @NOTE: 针对夜间模式
  night: {
    _changeMode: function(node) {
      var r1 = /SG_\wFONT_/;
      if (node.className.match(r1)) {
        return;
      }
      var computedStyle = getComputedStyle(node);
      var background = computedStyle.background;
      var fontSize = computedStyle.fontSize.replace(/px/, '');
      var size = 0;
      var tname = 'TFONT_';
      if (fontSize <= 12) {
        size = 0;
      } else {
        size = 1;
      }
      if (background.match(/url\(\s*[^)]+\)/) && !node.className.match(/SG_HAS_BGIMG/)) {
        node.className += ' SG_HAS_BGIMG';
      }
      node.className += ' SG_' + tname + size;
    },
    _enumChildNodes: function enumChildNodes(parentNode, callback) {
      if (!parentNode) return;
      var tname = parentNode && parentNode.tagName && parentNode.tagName.toLowerCase() || '';
      if (['script', 'style', 'iframe'].indexOf(tname) > -1 || tname === '') return;
      callback && callback(parentNode);
      for (var i = 0; i < parentNode.childNodes.length; i ++) {
        var item = parentNode.childNodes[i];
        if (item.nodeType !== 3) {
          enumChildNodes(item, callback);
        }
      }
    },
    domchanged: function(e) {
      var target = e.target;
      tryDoHack(this, document.body);
      this._enumChildNodes(target, this._changeMode);
    },
    maxcallback: function(from) {
      var _this = this;
      if (this.timer) {
        clearTimeout(this.timer);
      }
      if (this.max > 0) {
        tryDoHack(this, document.documentElement);
        this._enumChildNodes(document.body, this._changeMode);
        this.timer = setTimeout(function() {
          if (from === 'timer')
            --_this.max;
          _this.maxcallback('timer');
        }, 500);
      }
    },
    max: 6,
    always: function(type) {
      var _this = this;
      if (type === 'install') {
        if (document.readyState == 'interactive') {
          _this._enumChildNodes(document.body, _this._changeMode);
          tryDoHack(_this, document.documentElement);
        } else {
          document.addEventListener('DOMContentLoaded', function() {
            _this._enumChildNodes(document.body, _this._changeMode);
            tryDoHack(_this, document.documentElement);
          });
        }
        _this.callback = _this.maxcallback.bind(_this);
        window.addEventListener('scroll', _this.callback);
        window.addEventListener('load', _this.callback);
        _this.callback();
        document.addEventListener('DOMNodeInsertedIntoDocument', this.domchanged.bind(this));
      } else {
        document.removeEventListener('DOMNodeInsertedIntoDocument', this.domchanged);
        if (_this.callback) {
          window.removeEventListener('scroll', _this.callback);
        }
      }
    },
    list: []
  }
};

// @NOTE: 网页保护色模式
var hackAlias = {
  pink: '__color__',
  orange: '__color__',
  turquoise: '__color__',
  lushgreen: '__color__',
  __color__: {
    // @NOTE:
    // 不做处理网站列表 - domain 级别.
    before: function(mode) {
      var list = [
        'http://bazinga.mse.sogou.com/zixun/image.html',
        /weather\.com\.cn/,
        /read\.m\.sohu\.com/
      ];
      return  matches(list) === false;
    },
    maxcallback: function() {
      if (this.max > 0) {
        tryDoHack(this, document.documentElement);
        --this.max;
      }
    },
    max: 3,
    always: function(step) {
      var _this = this;
      if (step === 'install') {
        if (document.readyState == 'interactive') {
          tryDoHack(_this, document.documentElement);
        } else {
          document.addEventListener('DOMContentLoaded', function() {
            tryDoHack(_this, document.documentElement);
          });
        }
        _this.callback = _this.maxcallback.bind(_this);
        window.addEventListener('scroll', _this.callback);
        window.addEventListener('load', function() {
          tryDoHack(_this, document.documentElement);
        });
        var MutationObserver = window.MutationObserver || window.WebKitMutationObserver;
        this.observer = new MutationObserver(function(mutations) {
          if (mutations.some(function(mutation) {
            return mutation.target === document.body;
          })) {
            return tryDoHack(_this, document.body);
          }
          mutations.forEach(function(mutation) {
            if (mutation.type === 'childList') {
              var hasNode = walkToRoot(mutation.target, function(node) {
                if (node.hasAttribute && node.hasAttribute(__defined_ignore__)) {
                  return true;
                }
              }, document.body);
              if (!hasNode) {
                requestAnimationFrame(function() {
                  tryDoHack(_this, mutation.target);
                })
              }
            }
          });
        });
        var config = {
          childList: true,
          subtree: true
        };
        this.observer.observe(document.documentElement, config);
      } else if (step === 'uninstall') {
        if (this.observer) {
          this.observer.disconnect();
        }
        if (_this.callback) {
          window.removeEventListener('scroll', _this.callback);
        }
      }
    },
    list: [
      {
        order: [
          {
            // 忽略 fullpage 检测
            filter: [
              /yd\.sogou\.com/,
              /(?:english|mingyi|yd)\.sogou\.com/,
              /fuwu\.wap\.sogou\.com/,
              /m\.miercn\.com/,
              /m\.(?:tv|film)\.sohu\.com/,
              /ctrip\.com/,
              /blog\.sina\.cn/
            ],
            handle: __ignorefullpage
          },
          {
            filter: /ifeng\.com/,
            forceTriggerColorSelectors: [
              '#slNavBox',
              '.ifeng-box'
            ],
            forceIgnoreColorSelectors: [
              '.acTit .wrap',
              '.index-bar'
            ]
          },
          {
           // 忽略节点 - 即不设置样式
            filter: /(?:yd|zhihu)\.sogou\.com/i,
            forceIgnoreColorSelectors: [
              '.search-wrap',
              '.querybox',
              '.detail-top'
            ]
          },
          {
            filter: /sina\.cn/i,
            forceIgnoreColorSelectors: [
              '#j_navGroup',
              '.n_tab_card ',
              'header'
            ],
            forceTriggerColorSelectors: [
              '.f_card_lricon',
              '.load-wrap',
              '.weekHot',
              '.weekHotList',
              '.weekHotList .list',
              '.newBookListcon .list',
              '.newBook',
              '.channel',
              '.channel .list',
              '.con_list',
              '.exclusive',
              '.check-more',
              '.n_list .toggle_btn_up',
              '.f_card',
              '.f_card_icon',
              '.j_native',
              '.carditems_list',
              '.carditems_list_opright',
              '.carditems, .carditems-live'
            ]
          },
          {
            filter: /ganji\.com/,
            handle: function() {
              var node = document.querySelector('.infor-scroll');
              node.style.backgroundColor = '#fff';
            }
          }
        ],
        handler: function() {
          var order = this.order;
          for (var i = 0; i < order.length; ++i) {
            var cfg = order[i];
            var use = matches(cfg.filter);
            if (use) {
              if (cfg.forceTriggerColorSelectors) {
               __addnodebyselector(cfg.forceTriggerColorSelectors);
              }
              if (cfg.forceIgnoreColorSelectors) {
                __ignorenodebyselector(cfg.forceIgnoreColorSelectors);
              }
              if (cfg.handle) {
                cfg.handle(cfg);
              }
            }
          }
        }
      },
      {
        // 针对 domain 过滤.
        // 支持: null/string/array
        // host: '',
        // 针对 url 过滤.
        // 支持: string/regexp/function
        // 满足时, 返回 true;
        // filter: /./,
        // 当满足上面过滤条件时,
        // 逐个调用 handler...
        handler: [
          function(root) {
            walk(root || document.body, {
              handle: function(node) {
                if (node && node.nodeType == 1) {
                  if (!node.__fixed) {
                    node.__fixed = 1;
                    return handleNode(node);
                  }
                }
              },
              complete: function() {}
            });
          }
        ]
      }
    ]
  }
};

var regexpcache = {};

function __ignorenodebyselector(selectors) {
  selectors.forEach(function(selector) {
    var nodes = document.querySelectorAll(selector);
    for (var i = 0; i < nodes.length; ++i) {
      var node = nodes[i];
      if (node) {
        node.setAttribute(__defined_ignore__, 'selector');
        __removeAttribute(node);
      }
    }
  });
}

function __ignorefullpage() {
  document.body.setAttribute(__defined_ignore_fullpage__, 'full');
}

function __addnodebyselector(selectors) {
  selectors.forEach(function(selector) {
    var nodes = document.querySelectorAll(selector);
    for (var i = 0; i < nodes.length; ++i) {
      var node = nodes[i];
      if (node) {
        node.setAttribute(__defined__, 'selector');
      }
    }
  });
}

function __filtertags(node) {
  // 标签过滤处理
  var tags = [
    'meta',
    'link',
    'title',
    'style',
    'script',
    'noscript',
    'iframe',
    'img',
    'video',
    'audio',
    'menu',
    'i',
    'input'
  ];
  var tagname = node.nodeName.toLowerCase();
  var parentTagName = '';
  if (node.parentNode) {
    parentTagName = node.parentNode.tagName;
  }
  if (
    tags.indexOf(tagname) > -1 ||
    (
      /^h\d$/i.test(parentTagName) && (!__addbystyle(node))
    )
  ) {
    return true;
  }
}

function __filterscheme(node) {
  // 过滤伪协议 - 认为是操作按钮
  if (
    node.nodeName.toLowerCase() === 'a' &&
    /(?:javascript|mailto):|#/i.test(node.href)
  ) {
    return true;
  }
}

function __filterclassname(node) {
  // 特殊 class 过滤
  var filterClasses = [
    /contentbar/i,
    /mianbaoline/i,
    /subnavlist/i,
    /fashion-nav/i,
    /logo/i,
    /callicon/i,
    /icon/i,
    /newnav/i,
    /tit/i,
    /mask/i,
    /cover/i,
    /(?!card_)layer/i,
    /blur/i,
    /photo/i,
    /tuji/i,
    /image/i,
    /pic/i,
    /btn/i,
    /ad[\-\_]/i,
    /[\-\_]show/i,
    /dot/i,
    /top/i,
    /back/i,
    /hot(?!_news)/i,
    /outline/i,
    /headline/i,
    /site(?!-nav)/i,
    /slide/i,
    /swipe/i,
    /qlist/i,
    /ui_focus/i,
    /vHeader_mobile/i,
    /h_module/i,
    /n_menu_card/i,
    /weather/i,
    /article-more/i,
    /x-resolution-panel/i,
    /cmt-total/i,
    /input-box/i,
    /box-header/i,
    /searchBox/i,
    /(?:app|zg)-wrap/i,
    /flexWrap/i,
    /play/i
  ];
  for (var i = 0; i < filterClasses.length; ++i) {
    if (node.className && filterClasses[i].test(node.className)) {
      return true;
    }
  }
}

// 添加名单机制.
function __filterstyle(node) {
  var style = window.getComputedStyle(node);
  var isFixed = style.position === 'fixed';
  var isAbsolute = style.position === 'absolute';
  var isFullWidth =  style.width == window.innerWidth + 'px';
  var isFullHeight = style.height == window.innerHeight + 'px';
  var isBodyNode = node.tagName === 'BODY';
  var isIgnoreFullPage = isBodyNode && node.hasAttribute(__defined_ignore_fullpage__);
  if (
     isFixed ||
    (isAbsolute && isFullWidth) ||
    (!isIgnoreFullPage && isFullHeight && isFullWidth && isBodyNode) ||
    (isAbsolute && style.left == style.right && style.top == style.bottom && style.left == '0px' && style.top == '0px')
  ) {
    return true;
  }
}

function __filterids(node) {
  var ids = [
    /slide/i,
    /j-header/i,
    /headerimg/i
  ];
  for (var i = 0; i < ids.length; ++i) {
    if (node.id && ids[i].test(node.id)) {
      return true;
    }
  }
}

function __addbytags(node) {
  // 有针对性的添加样式.
  var tags = [
    'body',
    'footer',
    'header',
    'article',
    'aside',
    'section'
  ];
  var tagname = node.nodeName.toLowerCase();
  if (tags.indexOf(tagname) > -1) {
    return true;
  }
}

function __addbycontrol(node) {
  // @todo.
}

function __addbyclassname(node) {
  var useClasses = [
    /\b(?:section|seation)\b/i,
    /^pro-item/i,
    /dudu-head/i,
    /abstract/i,
    /main/i,
    /content/i,
    /area/i,
    /nav-urls/i,
    /result/i,
    /[^vh]wrap|wrap./i,
    /box.*(?!header)/i,
    /module/i,
    /[^_]list/i,
    /(?!nav_)item/i,
    /line/i,
    /card/i,
    /article/i,
    /block/i,
    /group/i,
    /total/i,
    /layout/i,
    /container/i,
    /pic_info/i,
    /suggestion/i,
    /search_list/i,
    /chapter/i
  ];
  for (var i = 0; i < useClasses.length; ++i) {
    if (node.className && useClasses[i].test(node.className)) {
      return true;
    }
  }
}

function __addbyid(node) {
  var ids = [
    /^control/i,
    /tags/i,
    /wrap/i,
    /main/
  ];
  for (var i = 0; i < ids.length; ++i) {
    if (node.id && ids[i].test(node.id)) {
      return true;
    }
  }
}

function __addbyattribute(node) {
  var attributes = [];
  for (var i = 0; i < attributes.length; ++i) {
    var attribute = attributes[i];
    if (node.hasAttribute(attribute)) {
      return true;
    }
  }
}

function __addbystyle(node) {
  var style = window.getComputedStyle(node);
  if (style.backgroundColor === 'rgb(255, 255, 255)') {
    return true;
  }
}

function __addbyspecial(node) {
  var noclassname = node.className == '';
  var pnode = node.parentNode;
  var pv = pnode.getAttribute && pnode.getAttribute(__defined__);
  if (
    noclassname && pv && pv !== 'ignore'
  ) {
    return true;
  }
}

function __removeAttribute(node) {
  var hasNode = node;
  walkToRoot(node, function(node) {
    if (node.nodeType == 1 && node.hasAttribute(__defined_ignore__)) {
      hasNode = node;
    }
  }, document.body);
  walk(hasNode, {
    handle: function(node) {
      if (node.nodeType == 1) {
        node.removeAttribute(__defined__);
        node.removeAttribute(__defined_reset__);
        if (node !== hasNode) {
          node.removeAttribute(__defined_ignore__);
        }
      }
    }
  });
}

function __checkNode(node, base) {
  var hasNode = base;
  walkToRoot(node, function(node) {
    if (node.hasAttribute && node.hasAttribute(__defined_ignore__)) {
      hasNode = node;
    }
  }, document.body);
  if (hasNode) {
    __removeAttribute(hasNode);
    return true;
  }
}

function __fixedNode(node) {
  if (node.hasAttribute(__defined_ignore__)) {
    __removeAttribute(node);
    return true;
  }
  if (
    node.hasAttribute(__defined__) ||
    node.hasAttribute(__defined_reset__)
  ) {
    return __checkNode(node);
  }
}

// JavaScript 版本过滤模式.
function handleNode(node) {
  var is = __fixedNode(node);
  if (is) {
    return;
  }

  // 是否添加标记.
  var add = '';
  var ignore = '';

  if (!add && __addbytags(node)) {
    add = 'tag';
  }
  if (!add && __addbyclassname(node)) {
    add = 'classname';
  }
  if (!add && __addbyid(node)) {
    add = 'id';
  }
  if (!add && __addbyattribute(node)) {
    add = 'attribute';
  }
  if (!add && __addbyspecial(node)) {
    add = 'special';
  }
  if (!add && __addbystyle(node)) {
    // add = 'style';
  }

  if (add) {
    if (__filtertags(node)) {
      ignore = 'tag';
    }
    if (!ignore && __filterscheme(node)) {
      ignore = 'scheme';
    }
    if (!ignore && __filterclassname(node)) {
      ignore = 'classname';
    }
    if (!ignore && __filterstyle(node)) {
      ignore = 'style';
    }
    if (!ignore && __filterids(node)) {
      ignore = 'id';
    }
    if (ignore) {
      requestAnimationFrame(function() {
        node.setAttribute(__defined_ignore__, ignore);
      })
      __removeAttribute(node);
      add = false;
    }
  }
  if (add) {
    var is = __checkNode(node)
    if (!is) {
      requestAnimationFrame(function() {
        node.setAttribute(__defined__, __debug__ ? add : 1);
      })
    }
  }
}

// 兼容老版本夜间模式
;(function(night) {
  if (!night) return;

  // @NOTE: cp from old vertion.
  // 当前节点, 还是所有子节点
  function addTransparentBG(node, only) {
    if (!node) {
      return;
    }
    var nodes = node.querySelectorAll('*');
    if (!nodes) {
      return;
    }
    if (!node.classList.contains('SG_TRANSPARENT_BG')) {
      node.classList.add('SG_TRANSPARENT_BG');
    }
    if (only) {
      return;
    }
    var elem, i = 0, len = nodes.length;;
    for (; i < len; i ++) {
      if (!nodes[i].classList.contains('SG_TRANSPARENT_BG')) {
        nodes[i].classList.add('SG_TRANSPARENT_BG');
      }
    }
  }
  function addSpecialClass(node, classname) {
    if (node) {
      node.classList.add(classname);
    }
  }
  var bindTransparent = function() {
    this.__selector__transparent.forEach(function(selector) {
      console.log('selector:', selector, document.querySelector(selector));
      addTransparentBG(
        document.querySelector(selector)
      );
    });
  };
  var bindTransparentOnly = function() {
    this.__selector__transparent_only.forEach(function(selector) {
      addTransparentBG(
        document.querySelector(selector), true
      );
    });
  };
  var bindTransparents = function() {
    this.__selector__transparents.forEach(function(selector) {
      var nodes = document.querySelectorAll(selector);
      for (var i = 0; i < nodes.length; ++i) {
        addTransparentBG(nodes[i]);
      }
    });
  };
  var bindSpecialClass = function() {
    for (var selector in this.__selector__special_class) {
      var node = document.querySelector(selector);
      if (node) {
        node.classList.add(this.__selector__special_class[selector]);
      }
    }
  };
  var bindSpecialClasses = function() {
    for (var selector in this.__selector__special_classes) {
      var nodes = document.querySelectorAll(selector);
      for (var i = 0; i < nodes.length; ++i) {
        nodes[i].classList.add(this.__selector__special_classes[selector]);
      }
    }
  };

  var webConfig = {
    'm.baidu.com': {
      transparent: [
        '.baiduapp-icon'
      ]
    },
    'image.baidu.com': {
      transparent: [
        '#searchbox-topel',
        '.virtualsearch'
      ]
    },
    'm.sohu.com': {
      transparents: [
        '.page-wrapper',
        '.cnl .h em'
      ]
    },
    'wapiknow.baidu.com': {
      specialClass: {
        '.click-load-more .load-button': 'SG_COLOR_333'
      }
    },
    'k.sogou.com': {
      specialClass: {
        '.searchBox .querybox': 'SG_NORMAL_BG',
        '#submit_btn': 'SG_NORMAL_BG'
      }
    },
    'm.acfun.tv': {
      transparentOnly: [
        '.area-b'
      ]
    },
    'info.3g.qq.com': {
      transparent: [
        '#hd-wrap',
        '.lk-sogou'
      ],
      specialClass: {
        '.srch-input': 'SG_NORMAL_BG'
      }
    },
    'm.acfun.tv': {
      transparentOnly: [
        '.area-b'
      ]
    },
    'info.3g.qq.com': {
      transparent: [
        '#hd-wrap',
        '.lk-sogou',
        '.list-slideImage'
      ],
      specialClass: {
        '.srch-input': 'SG_NORMAL_BG'
      }
    },
    'm.taobao.com': {
      transparent: [
        '#content',
        '#guessitem'
      ],
      specialClass: {
        '#search-placeholder': 'SG_SPECIAL_BG'
      }
    },
    'tv.ifeng.com': {
      transparent: [
        '.ifeng-foot',
        '.swiper-container',
        '.vHeader_mobile .vlogo'
      ],
      transparents: [
        '.ifeng-container .ifeng-box'
      ]
    },
    '3g.ifeng.com': {
      transparents: [
        '.i_slide .tempWrap ul li p',
        '.i_slide .i_slide_page'
      ]
    },
    'i.ifeng.com': '3g.ifeng.com',
    'www.youku.com': {
      transparent: [
        '#MYYOUKU-Recommend',
        '#sideBar'
      ],
      transparents: [
        '.yk-container div[name=m_pos] .videolist'
      ],
      specialClass: {
        '.addDesktop_iphone .tipPanel': 'SG_AB_BG'
      }
    },
    'm.weibo.cn': {
      transparents: [
        '.card .vip-card'
      ],
      transparentOnly: [
        '.operate-box'
      ]
    },
    'passport.weibo.cn': {
      transparent: [
        '#loginWrapper form'
      ]
    },
    'jingyan.baidu.com': {
      transparent: [
        '#slider'
      ],
      transparents: [
        '#guessLike .good-mag li .guess-like-title'
      ],
      specialClasses: {
        '#guessLike .good-mag .like-list .item': 'SG_COLOR_WHITE',
        '.ui-refresh-down': 'SG_COLOR_333',
        '#footer .login a': 'SG_COLOR_333',
        '.flat-footer .search .submit': 'SG_COLOR_333'
      }
    },
    'm.tv.sohu.com': {
      specialClass: {
        '.js_header .js_nav_search': 'SG_NORMAL_BG'
      },
      transparent: [
        '.js_header .js_nav_search'
      ]
    },
    'dh.123.sogou.com': {
      transparent: [
        '.container .hotword'
      ],
      transparents: [
        '.pic-list li p.tx',
        '.minx-pic-list li p.tx'
      ],
      specialClass: {
        '.search_box .search_bar': 'SG_NORMAL_BG'
      }
    },
    'm.weather.com.cn': {
      transparents: [
        '.sk > h1',
        '.sk > h2',
        '.sk > h3'
      ]
    },
    'm.sogou.com': {
      transparentOnly: [
        '#searchform'
      ],
      transparent: [
        '.index-star',
        '#locallife',
        '#star'
      ],
      transparents: [
        '#tool div',
        '#smile div',
        '#commpk div',
      ],
      specialClass: {
        '.searchBox-th-default': 'SG_NORMAL_BG',
        '#searchform .querybox': 'SG_NORMAL_BG',
        '#tool': 'SG_SPECIAL_BG',
        '#smile': 'SG_SPECIAL_BG',
        '#smile > a': 'SG_SPECIAL_BG',
        '#commpk': 'SG_SPECIAL_BG'
      }
    },
    'm.tianqi.sogou.com': {
      transparents: [
        '.index .header .header-hd',
        '.index .header .header-info'
      ]
    },
    'bazinga.mse.sogou.com': {
      transparents: [
        '#tuji .detail-bd-wrap .info',
        '#discuss .article-tuji'
      ],
      specialClass: {
        '#tuji .detail-bd-wrap .info .index p': 'SG_TFONT_2',
        '#tuji .detail-bd-wrap .info .index div': 'SG_TFONT_2',
        '.swiper-slide-active': ''
      }
    },
    'wap.sogou.com': 'm.sogou.com',
    '3g.163.com': {
      transparent: [
        '.headslide .ctrls'
      ],
      specialClass: {
        '.topnav_list_contain': 'NO_SIDE_STYLE',
        '.subnav_wrap': 'NO_SIDE_STYLE',
        '.subnav_wrap:after': 'NO_SIDE_STYLE'
      }
    },
    'k.sogou.com': {
      transparentOnly: [
        '#head_search_form',
        '#foot_search_form'
      ],
      specialClass: {
        '#head_search_form .querybox': 'SG_NORMAL_BG',
        '#foot_search_form .querybox': 'SG_NORMAL_BG'
      },
      specialClasses: {
        '.list3_t4': 'SG_AFONT_2'
      }
    },
    'zhidao.baidu.com': {
      specialClass: {
        '.click-load-more .load-button': 'SG_AFONT_2'
      }
    },
    'm.tv.sohu.com': {
      transparents: [
        '.content_list .bottom_title',
        '.ui_focus .content_list .bottom',
        '.js_nav_search'
      ],
      transparentOnly: [
        '.ui_focus .index_list'
      ],
      specialClass: {
        '.js_nav_search': 'SG_SPECIAL_BG'
      }
    },
    'm.iqiyi.com': {
      transparentOnly: [
        '.carousel-dot'
      ],
      specialClasses: {
        '.m-linkMore a': 'SG_SPECIAL_BG',
        '.m-guide-footer .m-guide-download a': 'SG_SPECIAL_BG',
        '.m-guide-footer .m-guide-jump a': 'SG_SPECIAL_BG'
      }
    }
  };

  var list = night.list;
  var map = {};
  for (var domain in webConfig) {
    // 修正 alias 情况
    var _domain;
    if (typeof webConfig[domain] === 'string') {
      _domain = domain;
      domain = webConfig[domain];
    }
    // 初始化各个项
    if (!map[domain]) {
      var prevItem = webConfig[domain];
      var nextItem = map[domain] = {
        host: [domain]
      };
      nextItem.handler = [];
      if (prevItem.transparent) {
        nextItem.__selector__transparent = prevItem.transparent;
        nextItem.handler.push(bindTransparent);
      }
      if (prevItem.transparentOnly) {
        nextItem.__selector__transparent_only = prevItem.transparentOnly;
        nextItem.handler.push(bindTransparentOnly);
      }
      if (prevItem.transparents) {
        nextItem.__selector__transparents = prevItem.transparents;
        nextItem.handler.push(bindTransparents);
      }
      if (prevItem.specialClass) {
        nextItem.__selector__special_class = prevItem.specialClass;
        nextItem.handler.push(bindSpecialClass);
      }
      if (prevItem.specialClasses) {
        nextItem.__selector__special_classes = prevItem.specialClasses;
        nextItem.handler.push(bindSpecialClasses);
      }
      // 扩展 list.
      list.push(nextItem);
    }
    // 补 alias
    if (_domain) {
      map[domain].host.push(_domain);
    }
  }

})(hacks.night);

var prefix = 'sogou';

// @NOTE:
// 和浏览器约定 mode 名称
var modeclassMap = {
  __template__: '__template__classname__',
  'night': 'SOGOU_NIGHT_MODE',
  'pink': '__sogou-color--pink',
  'orange': '__sogou-color--orange',
  'turquoise': '__sogou-color--turquoise',
  'lushgreen': '__sogou-color--lushgreen'
};

/*
  用户自定义规则为
  在 html 标签上绑定自定义属性
  data-sogou-modename="user-defined-classname"
  modename 支持列表见 modeclassMap 中配置
  通用名称 - 即, 不同模式使用相同的 classname.
  data-sogou-all="__template__"
*/
function getUserDefinedClassName(mode) {
  var dt = html.dataset || {};
  var key = prefix + mode[0].toUpperCase() + mode.slice(1);
  return dt[key] || dt.all || '';
}

// @NOTE:
// 用来定义 mode 优先级
// 目前在浏览器内部实现 - 存在 native 提醒.
function caniuse(nextMode, prevMode) {
  return true;
}

// 如果设置为不支持的 mode, 就会认为是删除所有模式.
function setColorMode(mode, type) {
  // @NOTE: Debug 模式.
  if (typeof type === 'function') {
    type();
  }

  if (type !== 'init') {
    if (mode === currentColorMode) return;
    var cprt = caniuse(mode, currentColorMode);
    if (!cprt) return;
  }

  // 给 CSS 更多可能性
  var hostattr = 'data-' + prefix + '-host';
  var hrefattr = 'data-' + prefix + '-href';

  var isset = modeclassMap[mode] == null;
  html = window.SogouUtilsEX.toggleColorMode.html;

  // 从模式 x, 切换到模式 y.
  // 考虑到存在夜间模式, 这里做了 remove 操作.
  if (modeclassMap[currentColorMode] != null) {
    if (currentColorMode) {
      var cls = getUserDefinedClassName(currentColorMode) || modeclassMap[currentColorMode];
      html.classList.remove(cls);
      html.removeAttribute(hostattr);
      html.removeAttribute(hrefattr);
      afterChangeMode(currentColorMode, 'uninstall');
      currentColorMode = null;
    }
  }

  if (!isset) {
    // @NOTE:
    // 支持切面模式 - 以备对特殊网页做过滤
    var use = beforeChangeMode(mode);
    if (use === true) {
      currentColorMode = mode;
      var cls = getUserDefinedClassName(mode) || modeclassMap[mode];
      html.className = ' ' + cls + ' ' + html.className;
      html.setAttribute(hrefattr, location.href);
      html.setAttribute(hostattr, location.hostname);
      afterChangeMode(mode, 'install');
    }
  }
}

function beforeChangeMode(mode) {
  var isusemode = true;
  // 添加 alias
  // 只查找一级
  // 几种网页保护色后期处理模式相同
  var hack = hacks[mode] || hackAlias[hackAlias[mode]];
  if (hack) {
    if (typeof hack.before === 'function') {
      isusemode = hack.before(mode);
    }
  }
  return isusemode;
}

// 各种兼容性问题在这儿处理...
function afterChangeMode(mode, type) {
  var hack = hacks[mode] || hackAlias[hackAlias[mode]];
  if (hack) {
    var useSystemInstallCallback = true;
    if (typeof hack.always === 'function') {
      var ret = hack.always.call(hack, type);
      useSystemInstallCallback = type === 'install' ?
        (ret === false ? false : true) : useSystemInstallCallback;
    }
    if (useSystemInstallCallback && type === 'install') {
      tryDoHack(hack);
    }
  }
}

function tryDoHack(hack, node) {
  if (hack.list) {
    for (var i = 0, l = hack.list.length; i < l; ++i) {
      var item = hack.list[i];
      if (
        !item.host ||
        location.host === item.host ||
        (type(item.host) === 'array' && inarray(location.host, item.host))
      ) {
        var isNeedHandle = true;
        if (item.filter) {
          isNeedHandle = matches(item.filter);
        }
        if (isNeedHandle) {
          doHandle(item, node);
        }
      }
    }
  }
}

function doHandle(item, node) {
  if (typeof item.handler === 'function') {
    item.handler = [item.handler];
  }
  var handlers = item.handler;
  for (var j  = 0, n = handlers.length; j < n; ++j) {
    var handle = handlers[j];
    if (typeof handle === 'function') {
      requestAnimationFrame(function() {
        handle.call(item, node);
      })
    }
  }
}

window.SogouUtilsEX.toggleColorMode = setColorMode;
setColorMode.html = html;
setColorMode(currentColorMode, 'init');

})();