(function(win){
    var SG_PAGEFIND_TOTAL = 0;
    var SG_PAGEFIND_CURRENT = 0;
    var _highlight = function(node, word){

        /*
         * 注意：高亮后dom结构会改变
         * 1. 需跳过已高亮节点
         * 2. 子节点长度改变，不能缓存子节点长度
         */
        
        var skip = 0;
        if(node.nodeType == 3){
            word = word.toLowerCase();
            var pos = node.data.toLowerCase().indexOf(word);
            if(pos >= 0){
                SG_PAGEFIND_TOTAL++;
                var spanNode = document.createElement('sgfind');
                    spanNode.className = 'SG_PAGEFIND_HIGHLIGHT';
                var middlebit = node.splitText(pos);
                var endbit = middlebit.splitText(word.length);
                var middleclone = middlebit.cloneNode(true);

                spanNode.appendChild(middleclone);
                middlebit.parentNode.replaceChild(spanNode, middlebit);
                skip = 1;
            }
        }else if(node.nodeType == 1 && node.childNodes && !/script|style/i.test(node.tagName)){
            // 过滤隐藏元素
            var nodeRect = node.getBoundingClientRect();
            if(nodeRect.width && nodeRect.height){
                for(var i = 0; i < node.childNodes.length; ++i){
                    i += _highlight(node.childNodes[i], word);
                }
            }
        }
        return skip;
    };

    var _cancel = function(){
        SG_PAGEFIND_TOTAL = 0;
        SG_PAGEFIND_CURRENT = 0;
        [].forEach.call(document.querySelectorAll('.SG_PAGEFIND_HIGHLIGHT'), function(el){
            with(el.parentNode){
               replaceChild(el.firstChild, el);
               normalize();
            }
        });
    };

    var _find = function(word){
        _cancel();
        if(word.length > 0 && !/^\s+$/.test(word)){
            _highlight(document.body, word);
            SG_PAGEFIND_TOTAL && _gotoIndex(++SG_PAGEFIND_CURRENT);
            return JSON.stringify({
                current: SG_PAGEFIND_CURRENT,
                total: SG_PAGEFIND_TOTAL
            })
        }else{
            return JSON.stringify({
                current: 0,
                total: 0
            })
        }
    };

    var _gotoIndex = function(cur){
        var clsNode, curNode, rect, docTop;
        var viewport = (document.querySelector('[name="viewport"]') || '').content || '';
        var scale = viewport.match(/initial-scale\s*=\s*([^,\s]+)/i);
            scale = +(scale ? scale[1] : 1);

        // 修正SG_PAGEFIND_CURRENT
        SG_PAGEFIND_CURRENT = cur < 1 ? SG_PAGEFIND_TOTAL : cur > SG_PAGEFIND_TOTAL ? 1 : SG_PAGEFIND_CURRENT;

        clsNode = document.querySelector('.SG_PAGEFIND_CURRENT');
        curNode = document.querySelectorAll('.SG_PAGEFIND_HIGHLIGHT').item(SG_PAGEFIND_CURRENT - 1);

        clsNode && clsNode.classList.remove('SG_PAGEFIND_CURRENT');
        curNode && curNode.classList.add('SG_PAGEFIND_CURRENT');

        // 页面定位
        rect = curNode.getBoundingClientRect();
        docTop = document.documentElement.scrollTop || document.body.scrollTop;

        if(rect.top < 0 || rect.top > window.innerHeight){
            window.scrollTo(0, docTop + rect.top - 60/scale);
        }
    };

    var _findNext = function(){
        if(SG_PAGEFIND_TOTAL > 0){
            _gotoIndex(++SG_PAGEFIND_CURRENT);

            return JSON.stringify({
                current: SG_PAGEFIND_CURRENT,
                total: SG_PAGEFIND_TOTAL
            })
        }else{
            return JSON.stringify({
                current: 0,
                total: 0
            })
        }
    };

    var _findPrev = function(){
        if(SG_PAGEFIND_TOTAL > 0){
            _gotoIndex(--SG_PAGEFIND_CURRENT);

            return JSON.stringify({
                current: SG_PAGEFIND_CURRENT,
                total: SG_PAGEFIND_TOTAL
            })
        }else{
            return JSON.stringify({
                current: 0,
                total: 0
            })
        }
    };

    var style = document.createElement('style');
        style.type = 'text/css';
        style.innerHTML = '.SG_PAGEFIND_HIGHLIGHT{background:rgb(255,216,155);border-radius:2px}.SG_PAGEFIND_CURRENT{background:rgb(255,174,81);border-radius:2px;box-shadow:0 2px 4px rgba(144,70,0,0.5)}';
        document.getElementsByTagName('head')[0].appendChild(style);

    win.SeMobWebPageSearch = win.SeMobWebPageSearch || {};
    win.SeMobWebPageSearch.find = _find;
    win.SeMobWebPageSearch.next = _findNext;
    win.SeMobWebPageSearch.prev = _findPrev;
    win.SeMobWebPageSearch.cancel = _cancel;

}(window));